package com.qs.mp.admin.service;

import com.qs.mp.admin.domain.CouponPkg;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qs.mp.admin.domain.Ticket;
import com.qs.mp.admin.domain.param.CouponPkgParam;
import com.qs.mp.admin.domain.vo.CouponPkgVO;

/**
 * <p>
 * 券包表 服务类
 * </p>
 *
 * @author quanshu
 * @since 2022-04-29
 */
public interface ICouponPkgService extends IService<CouponPkg> {

    /**
     * 新增券包
     *
     * @param couponPkgParam
     * @return
     */
    boolean create(CouponPkgParam couponPkgParam);

    /**
     * 修改券包
     *
     * @param couponPkgParam
     * @return
     */
    boolean updateCouponPkg(CouponPkgParam couponPkgParam);

    /**
     * 券包详情
     *
     * @param id
     * @return
     */
    CouponPkgVO detail(Long id);

    /**
     * 删除券包
     *
     * @param id
     * @return
     */
    boolean delete(Long id);

    /**
     * 券包发券
     *
     * @param ticket
     * @param userId
     * @param refId
     */
    void distribute(Ticket ticket, Long userId, String couponPkgId);

    /**
     * 营销活动券包发券
     * @param userId
     * @param couponPkgId
     */
    void distributeByMarketing(Long userId, String couponPkgId);
}
